#
#	PSX BIOS calls
#
#########################################
	.macro	BIOSCALL type,num,name
	.text
	.align	2
	.globl	\name
	.text
	.set	noreorder
	.ent	\name
\name:	
	li	t0,\type
	jr	t0
	li	t1,\num
	.end	\name
	.endm
#########################################
	.macro  SYSTEMCALL num,name
	.text
	.align	2
	.globl	\name
	.text
	.set	noreorder
	.ent	\name
\name:	
	li	a0,\num
	syscall
	jr	ra
	.end	\name
	.endm

#########################################
# a0 call

	BIOSCALL	0xa0,0x00,open
	BIOSCALL	0xa0,0x01,lseek
	BIOSCALL	0xa0,0x02,read
	BIOSCALL	0xa0,0x03,write
	BIOSCALL	0xa0,0x04,close
	BIOSCALL	0xa0,0x05,ioctl
	BIOSCALL	0xa0,0x06,exit
	BIOSCALL	0xa0,0x08,getc
	BIOSCALL	0xa0,0x09,putc
	BIOSCALL	0xa0,0x0a,todigit
	BIOSCALL	0xa0,0x0b,atof
	BIOSCALL	0xa0,0x0c,strtoul
	BIOSCALL	0xa0,0x0d,strtol
	BIOSCALL	0xa0,0x0e,abs
	BIOSCALL	0xa0,0x0f,labs
	BIOSCALL	0xa0,0x10,atoi
	BIOSCALL	0xa0,0x11,atol
	BIOSCALL	0xa0,0x12,atob
	BIOSCALL	0xa0,0x13,setjmp
	BIOSCALL	0xa0,0x14,longjmp
	BIOSCALL	0xa0,0x15,strcat
	BIOSCALL	0xa0,0x16,strncat
	BIOSCALL	0xa0,0x17,strcmp
	BIOSCALL	0xa0,0x18,strncmp
	BIOSCALL	0xa0,0x19,strcpy
	BIOSCALL	0xa0,0x1a,strnpy
	BIOSCALL	0xa0,0x1b,strlen
	BIOSCALL	0xa0,0x1c,index
	BIOSCALL	0xa0,0x1d,rindex
	BIOSCALL	0xa0,0x1e,strchr
	BIOSCALL	0xa0,0x1f,strrchr
	BIOSCALL	0xa0,0x20,strpbrk
	BIOSCALL	0xa0,0x21,strspn
	BIOSCALL	0xa0,0x22,strcspn
	BIOSCALL	0xa0,0x23,strtok
	BIOSCALL	0xa0,0x24,strstr
	BIOSCALL	0xa0,0x25,toupper
	BIOSCALL	0xa0,0x26,tolower
	BIOSCALL	0xa0,0x27,bcopy
	BIOSCALL	0xa0,0x28,bzero
	BIOSCALL	0xa0,0x29,bcmp
	BIOSCALL	0xa0,0x2a,memcpy
	BIOSCALL	0xa0,0x2b,memset
	BIOSCALL	0xa0,0x2c,memmove
	BIOSCALL	0xa0,0x2d,memcmp
	BIOSCALL	0xa0,0x2e,memchr
	BIOSCALL	0xa0,0x2f,rand
	BIOSCALL	0xa0,0x30,srand
	BIOSCALL	0xa0,0x31,qsort
	BIOSCALL	0xa0,0x32,strtod
	BIOSCALL	0xa0,0x33,malloc
	BIOSCALL	0xa0,0x34,free
	BIOSCALL	0xa0,0x35,lsearch
	BIOSCALL	0xa0,0x36,bsearch
	BIOSCALL	0xa0,0x37,calloc
	BIOSCALL	0xa0,0x38,realloc
	BIOSCALL	0xa0,0x39,InitHeap
	BIOSCALL	0xa0,0x3a,_exit
	BIOSCALL	0xa0,0x3b,getchar
	BIOSCALL	0xa0,0x3c,putchar
	BIOSCALL	0xa0,0x3d,gets
	BIOSCALL	0xa0,0x3e,puts
	BIOSCALL	0xa0,0x3f,printf
//	BIOSCALL	0xa0,0x41,LoadTest
//	BIOSCALL	0xa0,0x42,Load
//	BIOSCALL	0xa0,0x43,Exec
//	BIOSCALL	0xa0,0x44,FlushCache
//	BIOSCALL	0xa0,0x45,InstallInterruptHandler
//	BIOSCALL	0xa0,0x46,GPU_dw
	BIOSCALL	0xa0,0x47,mem2vram
//	BIOSCALL	0xa0,0x48,SendGPU
	BIOSCALL	0xa0,0x49,GPU_cw
//	BIOSCALL	0xa0,0x4a,GPU_cwb
//	BIOSCALL	0xa0,0x4b,SendPackets
//	BIOSCALL	0xa0,0x4d,GetGPUStatus
	BIOSCALL	0xa0,0x4e,GPU_sync
//	BIOSCALL	0xa0,0x51,LoadExec
//	BIOSCALL	0xa0,0x52,GetSysSp
//	BIOSCALL	0xa0,0x54,_96_init
	BIOSCALL	0xa0,0x55,_bu_init
//	BIOSCALL	0xa0,0x56,_96_remove
//	BIOSCALL	0xa0,0x5b,dev_tty_init
//	BIOSCALL	0xa0,0x5c,dev_tty_open
//	BIOSCALL	0xa0,0x5d,dev_tty_5d
//	BIOSCALL	0xa0,0x5e,dev_tty_ioctl
//	BIOSCALL	0xa0,0x65,dev_card_open
//	BIOSCALL	0xa0,0x66,dev_card_read
//	BIOSCALL	0xa0,0x67,dev_card_write
//	BIOSCALL	0xa0,0x68,dev_card_close
//	BIOSCALL	0xa0,0x69,dev_card_firstfile
//	BIOSCALL	0xa0,0x6a,dev_card_nextfile
//	BIOSCALL	0xa0,0x6b,dev_card_erase
//	BIOSCALL	0xa0,0x6c,dev_card_undelete
//	BIOSCALL	0xa0,0x6d,dev_card_format
//	BIOSCALL	0xa0,0x6e,dev_card_rename
//	BIOSCALL	0xa0,0x6f,dev_card_6f
//	BIOSCALL	0xa0,0x97,AddMemCardDevice
//	BIOSCALL	0xa0,0x98,DisableKernelIORedirection
//	BIOSCALL	0xa0,0x99,EnableKernelIORedirection
//	BIOSCALL        0xa0,0x9c,SetConf
//	BIOSCALL        0xa0,0x9d,GetConf
//	BIOSCALL	0xa0,0x9f,SetMem
//	BIOSCALL	0xa0,0xa0,_boot
//	BIOSCALL	0xa0,0xa1,SystemError
//	BIOSCALL	0xa0,0xa7,bufs_cb_0
//	BIOSCALL	0xa0,0xa8,bufs_cb_1
//	BIOSCALL	0xa0,0xa9,bufs_cb_2
//	BIOSCALL	0xa0,0xaa,bufs_cb_3
	BIOSCALL	0xa0,0xab,_card_info
	BIOSCALL	0xa0,0xac,_card_load
	BIOSCALL	0xa0,0xad,_card_auto
//	BIOSCALL	0xa0,0xae,bufs_cb_4
//	BIOSCALL	0xa0,0xb2,do_a_long_jmp

#b0 call
//	BIOSCALL	0xb0,0x00,SysMalloc
	BIOSCALL	0xb0,0x02,SetRCnt
//	BIOSCALL	0xb0,0x03,GetRCnt
	BIOSCALL	0xb0,0x04,StartRCnt
	BIOSCALL	0xb0,0x05,StopRCnt
	BIOSCALL	0xb0,0x06,ResetRCnt

	BIOSCALL	0xb0,0x07, DeliverEvent
	BIOSCALL	0xb0,0x08, OpenEvent
	BIOSCALL	0xb0,0x09, CloseEvent
	BIOSCALL	0xb0,0x0a, WaitEvent
	BIOSCALL	0xb0,0x0b, TestEvent
	BIOSCALL	0xb0,0x0c, EnableEvent
	BIOSCALL	0xb0,0x0d, DisableEvent
	BIOSCALL	0xb0,0x20, UnDeliverEvent

//	BIOSCALL	0xb0,0x0e,OpenTh
//	BIOSCALL	0xb0,0x0f,CloseTh
//	BIOSCALL	0xb0,0x10,ChangeTh
	BIOSCALL	0xb0,0x12,InitPAD
	BIOSCALL	0xb0,0x13,StartPAD
	BIOSCALL	0xb0,0x14,StopPAD
	BIOSCALL	0xb0,0x15,PAD_init
	BIOSCALL	0xb0,0x16,PAD_dr
	BIOSCALL	0xb0,0x17,ReturnFromException
	BIOSCALL	0xb0,0x18,ResetEntryInt
	BIOSCALL	0xb0,0x19,HookEntryInt
	BIOSCALL	0xb0,0x40,cd
	BIOSCALL	0xb0,0x41,format
      	BIOSCALL        0xb0,0x42,firstfile
	BIOSCALL	0xb0,0x43,nextfile
//	BIOSCALL	0xb0,0x44,rename
      BIOSCALL        0xb0,0x45,delete
//	BIOSCALL	0xb0,0x46,undelete
//	BIOSCALL	0xb0,0x47,AddDevice
//	BIOSCALL	0xb0,0x48,RemoteDevice
//	BIOSCALL	0xb0,0x49,PrintInstalledDevices
	BIOSCALL	0xb0,0x4a,InitCARD
	BIOSCALL	0xb0,0x4b,StartCARD
	BIOSCALL	0xb0,0x4c,StopCARD
	BIOSCALL	0xb0,0x4e,_card_write
	BIOSCALL	0xb0,0x4f,_card_read
	BIOSCALL	0xb0,0x50,_new_card
//	BIOSCALL	0xb0,0x51,Krom2RawAdd
//	BIOSCALL	0xb0,0x54,_get_errno
//	BIOSCALL	0xb0,0x55,_get_error
//	BIOSCALL	0xb0,0x56,GetC0Table
//	BIOSCALL	0xb0,0x57,GetB0Table
//	BIOSCALL	0xb0,0x58,_card_chan
	BIOSCALL	0xb0,0x5b,ChangeClearPAD
//	BIOSCALL	0xb0,0x5c,_card_status
//	BIOSCALL	0xb0,0x5d,_card_wait

# c0 call
//	BIOSCALL	0xc0,0x00,InitRCnt
//	BIOSCALL	0xc0,0x01,InitException
//	BIOSCALL	0xc0,0x02,SysEnqIntRP
//	BIOSCALL	0xc0,0x03,SysDeqIntRP
//	BIOSCALL	0xc0,0x04,get_free_EvCB_slot
//	BIOSCALL	0xc0,0x05,get_free_TCB_slot
//	BIOSCALL	0xc0,0x06,ExceptionHandler
//	BIOSCALL	0xc0,0x07,InstallExceptionHandler
//	BIOSCALL	0xc0,0x08,SysInitMemory
//	BIOSCALL	0xc0,0x09,SysInitKMem
//	BIOSCALL	0xc0,0x0a,ChangeClearRCnt
//	BIOSCALL	0xc0,0x0c,InitDefInt
//	BIOSCALL	0xc0,0x12,InstallDevices
//	BIOSCALL	0xc0,0x13,FlushStdInOutPut
//	BIOSCALL	0xc0,0x17,_circgetc
//	BIOSCALL	0xc0,0x18,_circputc
//	BIOSCALL	0xc0,0x19,ioabort
//	BIOSCALL	0xc0,0x1b,KernelRedirect
//	BIOSCALL	0xc0,0x1c,PatchAOTable

# syscall
	SYSTEMCALL	0,Exception
	SYSTEMCALL	1,EnterCriticalSection
	SYSTEMCALL	2,ExitCriticalSection
